version: '3.8'

services:
  # ----------------------------------------------------------------------------
  # Setup postgres services
  #
  postgres:
    image: postgres:13
    command: postgres -c 'max_connections=10000'
    container_name: colmena_postgres
    hostname: ${POSTGRES_HOSTNAME}
    environment:
      POSTGRES_USER: ${POSTGRES_USERNAME}
      POSTGRES_PASSWORD: ${POSTGRES_PASSWORD}
    ports:
      - "5432:5432"
    volumes:
      - 'pg_data:/var/lib/postgresql/data'
    networks:
      colmena_devops:
        aliases:
          - postgres

  pgadmin:
    container_name: colmena_pgadmin
    image: dpage/pgadmin4:latest
    environment:
        - PGADMIN_DEFAULT_EMAIL=${PGADMIN_DEFAULT_EMAIL}
        - PGADMIN_DEFAULT_PASSWORD=${PGADMIN_DEFAULT_PASSWORD}
    ports:
        - 5050:80
    volumes:
      - 'pgadmin_data:/var/lib/pgadmin'
    networks:
      colmena_devops:
        aliases:
          - pgadmin

  # ----------------------------------------------------------------------------
  # Setup nextcloud service
  #
  nextcloud:
    container_name: colmena_nextcloud
    image: colmena_nextcloud
    build:
      context: ../apps/nextcloud/
      dockerfile: builder/Dockerfile
      args:
        BUILD_CONTEXT: builder
        NEXTCLOUD_VERSION: ${NEXTCLOUD_VERSION}
        NEXTCLOUD_API_WRAPPER_PORT: ${NEXTCLOUD_API_WRAPPER_PORT}
        APACHE_APP_PATH: ${APACHE_APP_PATH}
    privileged: true
    networks:
      colmena_devops:
        ipv4_address: 172.20.0.10
    volumes:
      - ../apps/nextcloud/data:/var/www/html
    ports:
      - 8003:80
      - 8004:5001
    environment:
      - SQLITE_DATABASE=nextcloud
      - NEXTCLOUD_TRUSTED_DOMAINS=${NEXTCLOUD_TRUSTED_DOMAINS}
      - NEXTCLOUD_ADMIN_USER=${NEXTCLOUD_ADMIN_USER}
      - NEXTCLOUD_ADMIN_PASSWORD=${NEXTCLOUD_ADMIN_PASSWORD}

  # ----------------------------------------------------------------------------
  # Setup mail service
  #
  mail:
    container_name: colmena_mail
    image: colmena_mail
    build:
      context: ../apps/mailcrab
      dockerfile: builder/Dockerfile
      args:
        - MAILCRAB_VERSION=latest
    ports:
      - 1080:1080
      - 1025:1025
    networks:
      colmena_devops:
        aliases:
          - mail

networks:
  colmena_devops:
    driver: bridge
    ipam:
      driver: default
      config:
        - subnet: 172.20.0.0/16
volumes:
  pg_data:
  pgadmin_data:
